<script setup lang="ts">
import { nextTick, provide, ref } from 'vue'
import MemberView from './MemberView.vue'

import { userItemStore } from '@/stores/ItemList'

import { type Product } from '@/types/Product'

import ReceiptCard from '@/components/ReceiptCard.vue'
import ItemTable from '@/components/ItemTable.vue'
import ProductList from '../components/ProductList.vue'
import ReceiptDialog from '@/components/ReceiptDialog.vue'

const itemStore = userItemStore()
const drinks: Product[] = [
  { id: 1, name: 'Amaretto', price: 75.0, type: 'drink' },
  { id: 2, name: 'Ice Coffee', price: 65.0, type: 'drink' },
  { id: 3, name: 'Macha Latte', price: 75.0, type: 'drink' },
  { id: 4, name: 'Mocha', price: 75.0, type: 'drink' },
  { id: 5, name: 'Latte Macchiato', price: 115.0, type: 'drink' },
  { id: 6, name: 'Milk Shake', price: 105.0, type: 'drink' },
  { id: 7, name: 'Cola', price: 125.0, type: 'drink' },
  { id: 8, name: 'Latte', price: 85.0, type: 'drink' },
  { id: 9, name: 'Mint Choco', price: 65.0, type: 'drink' },
  { id: 10, name: 'Ice-cream with Soda', price: 75.0, type: 'drink' },
  { id: 11, name: 'Apple with Soda', price: 75.0, type: 'drink' },
  { id: 12, name: 'Ice Chocolate', price: 105.0, type: 'drink' }
]
const desserts: Product[] = [
  { id: 13, name: 'Pudding', price: 145.0, type: 'dessert' },
  { id: 14, name: 'Fig Cake', price: 115.0, type: 'dessert' },
  { id: 15, name: 'Fig and Cheese Pie', price: 135.0, type: 'dessert' },
  { id: 16, name: 'Cupcake', price: 115.0, type: 'dessert' },
  { id: 17, name: 'Biscoff Caramel', price: 85.0, type: 'dessert' },
  { id: 18, name: 'Cheese Cake', price: 75.0, type: 'dessert' },
  { id: 19, name: 'Orange Cookie', price: 55.0, type: 'dessert' },
  { id: 20, name: 'Butter Cookie', price: 65.0, type: 'dessert' },
  { id: 21, name: 'Blueberry Cake', price: 75.0, type: 'dessert' },
  { id: 22, name: 'Madeleine', price: 75.0, type: 'dessert' },
  { id: 23, name: 'Canele', price: 125.0, type: 'dessert' },
  { id: 24, name: 'Macarons', price: 110.0, type: 'dessert' }
]
const foods: Product[] = [
  { id: 25, name: 'Salad with Egg', price: 250.0, type: 'food' },
  { id: 26, name: 'French fries', price: 135.0, type: 'food' },
  { id: 27, name: 'Pizza', price: 175.0, type: 'food' },
  { id: 28, name: 'Sashimi', price: 145.0, type: 'food' },
  { id: 29, name: 'Tonkatsu Cheese', price: 235.0, type: 'food' },
  { id: 30, name: 'Rice and Curry', price: 85.0, type: 'food' },
  { id: 31, name: 'Kimchi Fried Rice', price: 55.0, type: 'food' },
  { id: 32, name: 'Pesto', price: 75.0, type: 'food' },
  { id: 33, name: 'Sandwich', price: 215.0, type: 'food' },
  { id: 34, name: 'Corndog', price: 115.0, type: 'food' },
  { id: 35, name: 'Jumeokbap', price: 285.0, type: 'food' },
  { id: 36, name: 'Udon', price: 265.0, type: 'food' }
]

const tab = ref(1)

const selected = (p: Product) => {
  console.log('ProductView', p)
  itemStore.addItem(p)
  nextTick(() => {
    if (divRecieptItems.value) divRecieptItems.value.scrollTo(0, divRecieptItems.value.scrollHeight)
  })
}
const divRecieptItems = ref<HTMLElement | null>(null)

const dialog = ref(false)
provide('receiptDialog', dialog)

const receiptBill = function () {
  itemStore.billDialog()
}
</script>

<template>
  <div class="app-container">
    <v-container class="ma-0" style="background-color: rgb(220, 164, 121)" fluid>
      <v-row>
        <v-col cols="12" md="6" xs="3" style="background-color: rgb(214, 175, 125)">
          <v-container style="padding: 0">
            <v-row>
              <v-col cols="12">
                <v-sheet
                  min-width="auto"
                  max-width="900"
                  height="70"
                  elevation="6"
                  style="
                    font-size: xx-large;
                    text-align: center;
                    background-color: rgb(155, 110, 65);
                    font-weight: bold;
                  "
                >
                  Product List
                </v-sheet>
              </v-col>
              <v-col cols="12">
                <!-- จอเลือกสินค้าด้านซ้ายใส่ตรงนี้ -->
                <v-sheet
                  min-width="auto"
                  max-width="900"
                  height="600"
                  elevation="6"
                  style="background-color: rgb(155, 110, 65)"
                >
                  <v-tabs
                    v-model="tab"
                    color="white"
                    align-tabs="center"
                    style="background-color: rgb(155, 110, 65)"
                  >
                    <v-tab :value="1">Drinks</v-tab>
                    <v-tab :value="2">Desserts</v-tab>
                    <v-tab :value="3">Foods</v-tab>
                  </v-tabs>
                  <v-window
                    v-model="tab"
                    md="6"
                    xs="3"
                    style="background-color: rgb(210, 165, 133)"
                  >
                    <v-window-item :value="1">
                      <ProductList :products="drinks" @selected-product="selected"></ProductList>
                    </v-window-item>
                    <v-window-item :value="2">
                      <ProductList :products="desserts" @selected-product="selected"></ProductList>
                    </v-window-item>
                    <v-window-item :value="3">
                      <ProductList :products="foods" @selected-product="selected"></ProductList>
                    </v-window-item>
                  </v-window>
                </v-sheet>
              </v-col>
            </v-row>
          </v-container>
        </v-col>

        <v-col cols="12" md="6" xs="3" style="background-color: rgb(78, 43, 17)">
          <!-- จอด้านขวาใส่ตรงนี้ -->
          <v-container style="padding: 0">
            <v-row no-gutters>
              <v-col cols="12">
                <v-sheet
                  min-width="auto"
                  max-width="900"
                  height="70"
                  elevation="1"
                  style="
                    font-size: xx-large;
                    text-align: center;
                    background-color: rgb(137, 87, 41);
                    font-weight: bold;
                  "
                >
                  Item List
                </v-sheet>
              </v-col>
              <v-col cols="12">
                <div ref="divRecieptItems" style="height: 250; overflow: auto">
                  <v-sheet
                    min-width="auto"
                    max-width="900"
                    height="440"
                    elevation="1"
                    style="background-color: rgb(87, 62, 40)"
                  >
                    <ItemTable></ItemTable>
                  </v-sheet>
                </div>
                <v-sheet
                  min-width="auto"
                  max-width="1000"
                  height="auto"
                  elevation="1"
                  style="background-color: rgb(183, 143, 81)"
                >
                  <v-container>
                    <v-row max-width="auto" height="180">
                      <v-col
                        cols="12"
                        sm="6"
                        xs="3"
                        style="background-color: rgb(73, 52, 16); height: auto; border:"
                      >
                        <MemberView></MemberView>
                      </v-col>
                      <v-col
                        cols="12"
                        sm="6"
                        xs="3"
                        style="background-color: rgb(95, 67, 19); height: auto; border:"
                      >
                        <ReceiptCard></ReceiptCard>
                        <v-row max-width="auto" height="auto">
                          <v-col cols="12" sm="6" xs="3" no-gutters>
                            <v-btn
                              color="red"
                              size="large"
                              prepend-icon="mdi-close-thick"
                              @click="
                                () => {
                                  itemStore.receiptDialog = false
                                  itemStore.clear()
                                }
                              "
                            >
                              Cancel
                            </v-btn>
                          </v-col>
                          <v-col cols="12" sm="6" xs="3" no-gutters>
                            <v-btn
                              color="green"
                              size="large"
                              prepend-icon="mdi-check-bold"
                              @click="receiptBill"
                            >
                              Confirm
                            </v-btn>
                          </v-col>
                        </v-row>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-sheet>
              </v-col>
            </v-row>
          </v-container>
        </v-col>
      </v-row>
    </v-container>
    <ReceiptDialog></ReceiptDialog>
  </div>
</template>

<style scoped>
.app-container {
  position: relative;
  height: 800px;
}

.app-container::before {
  content: '';
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: url('/cafe.png') no-repeat center center fixed;
  background-size: cover;
  opacity: 0.7;
  z-index: -1;
}
</style>
